/*
 * wiflyFreeRTOS.h
 *
 *  Created on: 06/12/2012
 *      Author: javier
 */

#ifndef WIFLYFREERTOS_H_
#define WIFLYFREERTOS_H_

#include "FreeRTOS.h"
#include "queue.h"
#include "semphr.h"
#include "wifly.h"

/*
 * Queue size and data type.
 */
#define terminalQUEUE_LENGTH     ( 1 )
#define terminalQUEUE_DATA_TYPE  ( sizeof( unsigned char ) )

#define dataQUEUE_LENGTH     ( 1 )
#define dataQUEUE_DATA_TYPE  ( sizeof( int ) )

#define httpQUEUE_LENGTH     ( 1 )
#define httpQUEUE_DATA_TYPE  ( sizeof( unsigned char ) )


struct _wiflyFreeRTOS {
	struct _wifly wifly;
	xSemaphoreHandle xMutexWifly;
	struct _uart uartDebug;
	xSemaphoreHandle xMutexUartDebug;
	xQueueHandle xQueueTerminalRead;
	xQueueHandle xQueueTerminalWrite;
	xQueueHandle xQueueDataRead;
	xQueueHandle xQueueDataWrite;
};


void WiFlyFreeRTOSsetWiFlyUart(struct _wiflyFreeRTOS *wiflyFreeRTOS, int port);
void WiFlyFreeRTOSsetUartDebug(struct _wiflyFreeRTOS *wiflyFreeRTOS, int port, int baudrate, int mode);
boolean WiFlyFreeRTOSbegin(struct _wiflyFreeRTOS *wiflyFreeRTOS);
boolean WiFlyFreeRTOSjoinAutoWPA(struct _wiflyFreeRTOS *wiflyFreeRTOS, char *ssid, char *passphrase);
boolean WiFlyFreeRTOSisAssociated(struct _wiflyFreeRTOS *wiflyFreeRTOS);
void WiFlyFreeRTOSemptyQueues(struct _wiflyFreeRTOS *wiflyFreeRTOS);

boolean WiFlyFreeRTOSterminalListen(struct _wiflyFreeRTOS *wiflyFreeRTOS);
unsigned long WiFlyFreeRTOSgetHTTPRequest(struct _wiflyFreeRTOS *wiflyFreeRTOS, char* url, byte *receiveBuffer, unsigned long maxLenght);


#endif /* WIFLYFREERTOS_H_ */
